/* =========================================================================

JavaScript Source File -- Created with SAPIEN Technologies PrimalScript 3.0

NAME: PoemsContent

AUTHOR: Azzis
DATE  : 18.01.2004

COMMENT:
     , 
        , 
  .

 ,       
  InDesign "Table of content"   
 ,         ( 
),     ,  
 "* * *",       
  ,   ,   
   ,   ,  ,  
  .

============================================================================ */
var VersionOfPoems = "0.9 beta"
with (app) {
	
	if (documents.length<1) {
		alert("  !");
		exit();
	}
	if (selection.length!=1) {
		alert("  ,\n    !");
		exit();
	}
	if ((selection[0].constructor.name!="TextFrame")&&(selection[0].constructor.name!="Text")&&(selection[0].constructor.name!="InsertionPoint")) {
		alert("    !");
		exit();
	}
	
	//Set up variables before make UI
	var myDoc = activeDocument;
	var mySelection = myDoc.selection[0];
	var myStory = myDoc.selection[0].parentStory;
	var myParagraphs = myStory.paragraphs;
	var myParaStyles = myDoc.paragraphStyles;
	
	//Create arrays for variable data
	var myParaStylesList = new Array();
	var myContentList = new Array();
	var myDialog = dialogs.add({name:"PoemsContent " + VersionOfPoems});
	
	//Fill arrays	
	for (var myCounter = 0; myCounter < myParaStyles.length; myCounter++) {
		myParaStylesList[myCounter] = myParaStyles[myCounter].name
	}
	
	with (myDialog.dialogColumns.add()){
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:" : ", minWidth:120});
			var mySelectedParaStyle = dropdowns.add({selectedIndex:0, stringList:myParaStylesList});
		}
		
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:" :", minWidth:120});
			var myContStyle = dropdowns.add({selectedIndex:0, stringList:myParaStylesList});
		}
		
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:"      :"});
			var myRepSymbol=textEditboxes.add({editContents: "* * *"});
		}
	}
	
	var myResult = myDialog.show();
	if (myResult == false) {
		exit();
	}
	
	if (mySelectedParaStyle.selectedIndex == 0) {
		alert("   !");
		exit();
	}
	
	if (myContStyle.selectedIndex == 0) {
		alert("   !");
		exit();
	}
	 
	var Res = new Array;
	Res=Res+"\r"
	//      Story
	for (var myCounter = 0; myCounter < myParagraphs.length; myCounter++) {
		//        
		if (myParagraphs[myCounter].appliedParagraphStyle.name == myParaStylesList[mySelectedParaStyle.selectedIndex]) {
			
			var myCurrentParagraph = myParagraphs[myCounter];
			var myContent = myCurrentParagraph.contents;
			
			//  
			var myFrame = myCurrentParagraph.parentTextFrame;
			var myPage = myFrame.parent;
			
			var myResContent = myContent;
			myResContent = myResContent.substr(0,myResContent.length-1);
			
			//        
			// ,   : "* * *",   
			//        
			//           
			//     
			if (myContent == myRepSymbol.editContents+'\r') {
				
				var myAfterPara = myParagraphs[myCounter+1].contents;
				var i = myAfterPara.length - 1;
				var cont = true;
				
				while (cont) {
					var cd = myAfterPara.charCodeAt(i);
					if ((cd == 13)||(cd == 32)||(cd == 46)||(cd == 44)||
						(cd == 33)||(cd == 63)||(cd == 8212)||(cd == 8211)||(cd == 45)) {
						i = i-1;
					}
					else cont = false;
				}
				
				myAfterPara = myAfterPara.substr(0,i+1);
				myResContent='\"'+myAfterPara+"...\""
			}
			Res = Res+myResContent+'\t'+myPage.name+'\r';
		}
	}
		
	var myPage = myDoc.pages.add(1701733408);
	var myBounds = myGetBounds(myPage,myDoc);
	
	with (myPage) {
		var myTextFrame = textFrames.add();
		myTextFrame.geometricBounds = myBounds;
		myTextFrame.contents = Res;
		
		var myParagraph = myTextFrame.paragraphs.item(0);
		myParagraph.appliedParagraphStyle = myParaStylesList[mySelectedParaStyle.selectedIndex];
		
		for (var myCounter = 1; myCounter < myTextFrame.paragraphs.length; myCounter++) {
			var myParagraph = myTextFrame.paragraphs.item(myCounter);
			myParagraph.appliedParagraphStyle = myParaStylesList[myContStyle.selectedIndex];
		}
	}
	myDialog.destroy();
	exit();
}

function myGetBounds(myPage, myDoc){
	var array = new Array()
	var item = 0;
	with (myDoc.documentPreferences){
		var myPageHeight = pageHeight;
		var myPageWidth = pageWidth;
	}

	with(myPage.marginPreferences){
		var myX1 = left;
		var myY1 = top;
		var myY2 = bottom;
		var myX2 = right;
	}
	
	array[item++] = myY1;
	array[item++] = myX1;
	array[item++] = myPageHeight - myY2;
	array[item++] = myPageWidth - myX2;
	
	return array;
}